c %Z% %M% %I% (IDS) %G%

C--- Southern Comm
      subroutine comm_south(win_d, upper, lower, max_iter, 
     &                      win_n, wr_south, wr_lower, co_lower, 
     &                      wrapd, width)  
        
      include "slgcm.slgprm"
      include "slgcm.mp"

      implicit none

      real      win_d(imp3,max_col_p3)
      integer   upper, lower
      integer   max_iter(2)
      real      win_n(imp3,jmp3)
      integer   wr_south, wr_lower, co_lower, wrapd, width
      
      integer nx, nx0, ny, ny0, nynth, nysth, nxest, nxwst
      common /commvars/ nx,nx0,ny,ny0, nynth, nysth, nxest, nxwst

      integer mp_send_and_rcvint

      integer c_range, c_upper, c_lower, t_lower
      integer wr_first
      integer i, j, k, tmp
      
      real      depart(imp3,max_col_p3)
      real      landing(imp3,max_col_p3)

        c_range = upper - lower + 1
        c_upper = upper
        c_lower = lower
        co_lower = lower

	k = 0
C	width = 0
        width = c_range
        wr_first = 0
        wr_south = 0
        wrapd = 0
        wr_lower = -1

        do i = 1, imp3
           do j = 1, c_range
              depart(i,j) = win_d(i,j)
              win_n(i,j) = win_d(i,j)
           end do
        end do


        do while (k .lt. max_iter(2))
          call mp_sync()
          tmp = mp_send_and_rcvint(nysth, 0, t_lower,
     &                             nynth, 0, c_lower)
C          width = width + c_range

          if (c_lower .eq. 1) then
	    wr_south = 1		
            wr_first = 1
	    c_upper = jmp3
	    c_lower = t_lower
	    c_range = jmp3 - t_lower + 1
          endif

	  if (wr_south .eq. 1) then
	    wr_lower = t_lower
            wrapd = jmp3 + 1 - wr_lower
	  endif

	  if (wr_south .eq. 0) then
	    co_lower = t_lower
	  endif

	if (wr_first .ne. 1) then
	  c_upper = c_lower - 1
	  c_lower = t_lower
	  c_range = c_upper - c_lower + 1
	endif

	wr_first = 0

          do i = 1, imp3
           do j = width, 1, -1
              win_n(i, c_range + j) = win_n(i, j)
           end do 
          end do

          width = width + c_range

         call mp_sync()
	 call circ_winbuf( nysth, 0, landing, imp3, max_col_p3,
     &                     nynth, 0, depart, imp3, max_col_p3)
           
         do i = 1, imp3
           do j = 1, c_range
              win_n(i, j) = landing(i, j)
              depart(i, j) = landing(i, j)
           end do 
         end do

	 k = k + 1
       end do
      
      end 
C subroutine comm_south

C
C
C
C--- Northern Comm
      subroutine comm_north(win_d, upper, lower, max_iter, 
     &                      win_n, wr_north, width)  
        
      include "slgcm.slgprm"
      include "slgcm.mp"

      implicit none

      real      win_d(imp3,max_col_p3)
      integer   upper, lower
      integer   max_iter(2)
      real      win_n(imp3,jmp3)
      integer   wr_north, width

      integer nx, nx0, ny, ny0, nynth, nysth, nxest, nxwst
      common /commvars/ nx,nx0,ny,ny0, nynth, nysth, nxest, nxwst
        
      integer mp_send_and_rcvint

      integer c_range, c_upper, c_lower, t_upper
      integer wr_first
      integer i, j, k, tmp
      
      real      depart(imp3,max_col_p3)
      real      landing(imp3,max_col_p3)

        c_range = upper - lower + 1
        c_upper = upper
        c_lower = lower

	k = 0
C	width = 0
        wr_first = 0
        wr_north = 0 

        do i = 1, imp3
           do j = 1, c_range
              depart(i,j) = win_d(i,j)
           end do
        end do

        do while (k .lt. max_iter(1))
           call mp_sync()
           tmp = mp_send_and_rcvint(nynth, 0, t_upper, 
     &                              nysth, 0, c_upper )

           print *, "NewUp ", t_upper, " CurUp ", c_upper

          if (c_upper .eq. jmp3) then
	    wr_north = 1		
            wr_first = 1
	    c_upper = t_upper
	    c_lower = 1
	    c_range = t_upper - c_lower + 1
          endif

	if (wr_first .ne. 1) then
            c_lower = c_upper + 1
            c_upper = t_upper
            c_range = c_upper - c_lower + 1
	endif

	wr_first = 0

            call mp_sync()
            call circ_winbuf( nynth, 0, landing, imp3, max_col_p3,
     &                        nysth, 0, depart, imp3, max_col_p3)


            do i = 1, imp3
               do j = 1, c_range
                  win_n(i, width + j) = landing(i, j)
                  depart(i, j) = landing(i, j)
               end do
            end do

            width = width + c_range
            k = k + 1
         end do

      end
C subroutine comm_north


C
C
C
C--- Northern Comm
      subroutine readjust_jj(jj, wr_south, wr_north, width,
     &                       wr_lower, co_lower, wrapd, njj)  
        
      include "slgcm.slgprm"
      include "slgcm.mp"

      implicit none

      integer   jj(imp3,max_col_p3)
      integer   wr_south, wr_north, width
      integer   wr_lower, co_lower, wrapd
      integer   njj(imp3,max_col_p3)

      integer i, j

        if ((wr_south .eq. 0) .and. 
     &      (wr_north .eq. 0)) then
          do i = 1, imp3
            do j = 1, max_col_p3
              njj(i, j) = jj(i, j) - co_lower + 1
            end do
          end do
        endif

        if (wr_south .eq. 1) then
          do i = 1, imp3
            do j = 1, max_col_p3
C               if (jj(i,j) .ge. wr_lower) then
               if (jj(i,j) .ge. wr_lower -3) then
                  njj(i,j) = jj(i, j) - wr_lower + 1
               else
                  njj(i,j) = jj(i,j) + wrapd
               endif
            end do
          end do
        endif
           
        if (wr_north .eq. 1) then
          do i = 1, imp3
            do j = 1, max_col_p3
               if (jj(i,j) .lt. co_lower) then
                  njj(i,j) = jj(i, j) + jmp3 - co_lower + 1
               else
                  njj(i,j) = jj(i,j) - co_lower + 1
               endif
            end do
          end do
        endif
      end


      subroutine findnew_jj(jj, jjp1, jjp2, jjp3, 
     *                      jjp4, width)

        integer jj, jjp1, jjp2
        integer jjp3, jjp4, width

        jjp1 = jj + 1
        if (jjp1 .gt. width) then
           jjp1 = jjp1 - width
        endif

        jjp2 = jj + 2
        if (jjp2 .gt. width) then
           jjp2 = jjp2 - width
        endif

        jjp3 = jj + 3
        if (jjp3 .gt. width) then
           jjp3 = jjp3 - width
        endif

        jjp4 = jj + 4
        if (jjp4 .gt. width) then
           jjp4 = jjp4 - width
        endif

      end
